diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/class-wp-plugin-install-list-table.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/class-wp-plugin-install-list-table.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/class-wp-plugin-install-list-table.php	2012-10-29 12:35:31.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/class-wp-plugin-install-list-table.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 29,38 ****
  		$tabs['dashboard'] = __( 'Search' );
  		if ( 'search' == $tab )
  			$tabs['search']	= __( 'Search Results' );
! 		$tabs['upload'] = __( 'Upload' );
! 		$tabs['featured'] = _x( 'Featured','Plugin Installer' );
! 		$tabs['popular']  = _x( 'Popular','Plugin Installer' );
! 		$tabs['new']      = _x( 'Newest','Plugin Installer' );
  
  		$nonmenu_tabs = array( 'plugin-information' ); //Valid actions to perform which do not have a Menu item.
  
--- 29,39 ----
  		$tabs['dashboard'] = __( 'Search' );
  		if ( 'search' == $tab )
  			$tabs['search']	= __( 'Search Results' );
! 		$tabs['upload']    = __( 'Upload' );
! 		$tabs['featured']  = _x( 'Featured', 'Plugin Installer' );
! 		$tabs['popular']   = _x( 'Popular', 'Plugin Installer' );
! 		$tabs['new']       = _x( 'Newest', 'Plugin Installer' );
! 		$tabs['favorites'] = _x( 'Favorites', 'Plugin Installer' );
  
  		$nonmenu_tabs = array( 'plugin-information' ); //Valid actions to perform which do not have a Menu item.
  
***************
*** 71,76 ****
--- 72,88 ----
  				$args['browse'] = $tab;
  				break;
  
+ 			case 'favorites':
+ 				$user = isset( $_GET['user'] ) ? stripslashes( $_GET['user'] ) : get_user_option( 'wporg_favorites' );
+ 				update_user_meta( get_current_user_id(), 'wporg_favorites', $user );
+ 				if ( $user )
+ 					$args['user'] = $user;
+ 				else
+ 					$args = false;
+ 
+ 				add_action( 'install_plugins_favorites', 'install_plugins_favorites_form', 9, 0 );
+ 				break;
+ 
  			default:
  				$args = false;
  		}
***************
*** 115,127 ****
  					<?php do_action( 'install_plugins_table_header' ); ?>
  				</div>
  				<?php $this->pagination( $which ); ?>
- 				<img src="<?php echo esc_url( admin_url( 'images/wpspin_light.gif' ) ); ?>" class="ajax-loading list-ajax-loading" alt="" />
  				<br class="clear" />
  			</div>
  		<?php } else { ?>
  			<div class="tablenav bottom">
  				<?php $this->pagination( $which ); ?>
- 				<img src="<?php echo esc_url( admin_url( 'images/wpspin_light.gif' ) ); ?>" class="ajax-loading list-ajax-loading" alt="" />
  				<br class="clear" />
  			</div>
  		<?php
--- 127,137 ----
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/class-wp-plugins-list-table.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/class-wp-plugins-list-table.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/includes/class-wp-plugins-list-table.php	2012-10-29 12:35:31.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/includes/class-wp-plugins-list-table.php	2012-12-17 16:18:41.000000000 -0600
***************
*** 9,17 ****
   */
  class WP_Plugins_List_Table extends WP_List_Table {
  
! 	function __construct() {
  		global $status, $page;
  
  		$status = 'all';
  		if ( isset( $_REQUEST['plugin_status'] ) && in_array( $_REQUEST['plugin_status'], array( 'active', 'inactive', 'recently_activated', 'upgrade', 'mustuse', 'dropins', 'search' ) ) )
  			$status = $_REQUEST['plugin_status'];
--- 9,22 ----
   */
  class WP_Plugins_List_Table extends WP_List_Table {
  
! 	function __construct( $args = array() ) {
  		global $status, $page;
  
+ 		parent::__construct( array(
+ 			'plural' => 'plugins',
+ 			'screen' => isset( $args['screen'] ) ? $args['screen'] : null,
+ 		) );
+ 
  		$status = 'all';
  		if ( isset( $_REQUEST['plugin_status'] ) && in_array( $_REQUEST['plugin_status'], array( 'active', 'inactive', 'recently_activated', 'upgrade', 'mustuse', 'dropins', 'search' ) ) )
  			$status = $_REQUEST['plugin_status'];
***************
*** 20,29 ****
  			$_SERVER['REQUEST_URI'] = add_query_arg('s', stripslashes($_REQUEST['s']) );
  
  		$page = $this->get_pagenum();
- 
- 		parent::__construct( array(
- 			'plural' => 'plugins',
- 		) );
  	}
  
  	function get_table_classes() {
--- 25,30 ----
***************
*** 31,43 ****
  	}
  
  	function ajax_user_can() {
- 		if ( is_multisite() ) {
- 			$menu_perms = get_site_option( 'menu_items', array() );
- 
- 			if ( empty( $menu_perms['plugins'] ) && ! is_super_admin() )
- 				return false;
- 		}
- 
  		return current_user_can('activate_plugins');
  	}
  
--- 32,37 ----
***************
*** 57,63 ****
  			'dropins' => array()
  		);
  
! 		$screen = get_current_screen();
  
  		if ( ! is_multisite() || ( $screen->is_network && current_user_can('manage_network_plugins') ) ) {
  			if ( apply_filters( 'show_advanced_plugins', true, 'mustuse' ) )
--- 51,57 ----
  			'dropins' => array()
  		);
  
! 		$screen = $this->screen;
  
  		if ( ! is_multisite() || ( $screen->is_network && current_user_can('manage_network_plugins') ) ) {
  			if ( apply_filters( 'show_advanced_plugins', true, 'mustuse' ) )
***************
*** 76,89 ****
  			}
  		}
  
! 		set_transient( 'plugin_slugs', array_keys( $plugins['all'] ), 86400 );
  
  		if ( ! $screen->is_network ) {
  			$recently_activated = get_option( 'recently_activated', array() );
  
- 			$one_week = 7*24*60*60;
  			foreach ( $recently_activated as $key => $time )
! 				if ( $time + $one_week < time() )
  					unset( $recently_activated[$key] );
  			update_option( 'recently_activated', $recently_activated );
  		}
--- 70,82 ----
  			}
  		}
  
! 		set_transient( 'plugin_slugs', array_keys( $plugins['all'] ), DAY_IN_SECONDS );
  
  		if ( ! $screen->is_network ) {
  			$recently_activated = get_option( 'recently_activated', array() );
  
  			foreach ( $recently_activated as $key => $time )
! 				if ( $time + WEEK_IN_SECONDS < time() )
  					unset( $recently_activated[$key] );
  			update_option( 'recently_activated', $recently_activated );
  		}
***************
*** 98,104 ****
  				|| ( $screen->is_network && is_plugin_active_for_network( $plugin_file ) ) ) {
  				$plugins['active'][ $plugin_file ] = $plugin_data;
  			} else {
! 				if ( !$screen->is_network && isset( $recently_activated[ $plugin_file ] ) ) // Was the plugin recently activated?
  					$plugins['recently_activated'][ $plugin_file ] = $plugin_data;
  				$plugins['inactive'][ $plugin_file ] = $plugin_data;
  			}
--- 91,97 ----
  				|| ( $screen->is_network && is_plugin_active_for_network( $plugin_file ) ) ) {
  				$plugins['active'][ $plugin_file ] = $plugin_data;
  			} else {
! 				if ( ! $screen->is_network && isset( $recently_activated[ $plugin_file ] ) ) // Was the plugin recently activated?
  					$plugins['recently_activated'][ $plugin_file ] = $plugin_data;
  				$plugins['inactive'][ $plugin_file ] = $plugin_data;
  			}
***************
*** 243,257 ****
  
  		$actions = array();
  
- 		$screen = get_current_screen();
- 
  		if ( 'active' != $status )
! 			$actions['activate-selected'] = $screen->is_network ? __( 'Network Activate' ) : __( 'Activate' );
  
  		if ( 'inactive' != $status && 'recent' != $status )
! 			$actions['deactivate-selected'] = $screen->is_network ? __( 'Network Deactivate' ) : __( 'Deactivate' );
  
! 		if ( !is_multisite() || $screen->is_network ) {
  			if ( current_user_can( 'update_plugins' ) )
  				$actions['update-selected'] = __( 'Update' );
  			if ( current_user_can( 'delete_plugins' ) && ( 'active' != $status ) )
--- 236,248 ----
  
  		$actions = array();
  
  		if ( 'active' != $status )
! 			$actions['activate-selected'] = $this->screen->is_network ? __( 'Network Activate' ) : __( 'Activate' );
  
  		if ( 'inactive' != $status && 'recent' != $status )
! 			$actions['deactivate-selected'] = $this->screen->is_network ? __( 'Network Deactivate' ) : __( 'Deactivate' );
  
! 		if ( !is_multisite() || $this->screen->is_network ) {
  			if ( current_user_can( 'update_plugins' ) )
  				$actions['update-selected'] = __( 'Update' );
  			if ( current_user_can( 'delete_plugins' ) && ( 'active' != $status ) )
***************
*** 261,273 ****
  		return $actions;
  	}
  
! 	function bulk_actions( $which ) {
  		global $status;
  
  		if ( in_array( $status, array( 'mustuse', 'dropins' ) ) )
  			return;
  
! 		parent::bulk_actions( $which );
  	}
  
  	function extra_tablenav( $which ) {
--- 252,264 ----
  		return $actions;
  	}
  
! 	function bulk_actions() {
  		global $status;
  
  		if ( in_array( $status, array( 'mustuse', 'dropins' ) ) )
  			return;
  
! 		parent::bulk_actions();
  	}
  
  	function extra_tablenav( $which ) {
***************
*** 278,287 ****
  
  		echo '<div class="alignleft actions">';
  
! 		$screen = get_current_screen();
! 
! 		if ( ! $screen->is_network && 'recently_activated' == $status )
! 			submit_button( __( 'Clear List' ), 'secondary', 'clear-recent-list', false );
  		elseif ( 'top' == $which && 'mustuse' == $status )
  			echo '<p>' . sprintf( __( 'Files in the <code>%s</code> directory are executed automatically.' ), str_replace( ABSPATH, '/', WPMU_PLUGIN_DIR ) ) . '</p>';
  		elseif ( 'top' == $which && 'dropins' == $status )
--- 269,276 ----
  
  		echo '<div class="alignleft actions">';
  
! 		if ( ! $this->screen->is_network && 'recently_activated' == $status )
! 			submit_button( __( 'Clear List' ), 'button', 'clear-recent-list', false );
  		elseif ( 'top' == $which && 'mustuse' == $status )
  			echo '<p>' . sprintf( __( 'Files in the <code>%s</code> directory are executed automatically.' ), str_replace( ABSPATH, '/', WPMU_PLUGIN_DIR ) ) . '</p>';
  		elseif ( 'top' == $which && 'dropins' == $status )
***************
*** 300,320 ****
  	function display_rows() {
  		global $status;
  
! 		$screen = get_current_screen();
! 
! 		if ( is_multisite() && !$screen->is_network && in_array( $status, array( 'mustuse', 'dropins' ) ) )
  			return;
  
  		foreach ( $this->items as $plugin_file => $plugin_data )
! 			$this->single_row( $plugin_file, $plugin_data );
  	}
  
! 	function single_row( $plugin_file, $plugin_data ) {
  		global $status, $page, $s, $totals;
  
  		$context = $status;
! 
! 		$screen = get_current_screen();
  
  		// preorder
  		$actions = array(
--- 289,307 ----
  	function display_rows() {
  		global $status;
  
! 		if ( is_multisite() && ! $this->screen->is_network && in_array( $status, array( 'mustuse', 'dropins' ) ) )
  			return;
  
  		foreach ( $this->items as $plugin_file => $plugin_data )
! 			$this->single_row( array( $plugin_file, $plugin_data ) );
  	}
  
! 	function single_row( $item ) {
  		global $status, $page, $s, $totals;
  
+ 		list( $plugin_file, $plugin_data ) = $item;
  		$context = $status;
! 		$screen = $this->screen;
  
  		// preorder
  		$actions = array(
***************
*** 380,386 ****
  
  		$class = $is_active ? 'active' : 'inactive';
  		$checkbox_id =  "checkbox_" . md5($plugin_data['Name']);
! 		$checkbox = in_array( $status, array( 'mustuse', 'dropins' ) ) ? '' : "<input type='checkbox' name='checked[]' value='" . esc_attr( $plugin_file ) . "' id='" . $checkbox_id . "' /><label class='screen-reader-text' for='" . $checkbox_id . "' >" . __('Select') . " " . $plugin_data['Name'] . "</label>";
  		if ( 'dropins' != $context ) {
  			$description = '<p>' . ( $plugin_data['Description'] ? $plugin_data['Description'] : '&nbsp;' ) . '</p>';
  			$plugin_name = $plugin_data['Name'];
--- 367,378 ----
  
  		$class = $is_active ? 'active' : 'inactive';
  		$checkbox_id =  "checkbox_" . md5($plugin_data['Name']);
! 		if ( in_array( $status, array( 'mustuse', 'dropins' ) ) ) {
! 			$checkbox = '';
! 		} else {
! 			$checkbox = "<label class='screen-reader-text' for='" . $checkbox_id . "' >" . sprintf( __( 'Select %s' ), $plugin_data['Name'] ) . "</label>"
! 				. "<input type='checkbox' name='checked[]' value='" . esc_attr( $plugin_file ) . "' id='" . $checkbox_id . "' />";
! 		}
  		if ( 'dropins' != $context ) {
  			$description = '<p>' . ( $plugin_data['Description'] ? $plugin_data['Description'] : '&nbsp;' ) . '</p>';
  			$plugin_name = $plugin_data['Name'];
